`timescale 1ns/1ps

module even_key_memory
#(
	parameter DATA_WIDTH   = 32,
	parameter DEPTH 	   = 20
)
(
    input  					    clk_i		,
    input  					    reset_ni	,
	input  					    keygen_en_i,
	input  [clogb2(DEPTH):0]    key_index	,
    input  [DATA_WIDTH-1 :0]    even_key_i	,
	
    output  [(DEPTH*DATA_WIDTH)-1:0]  even_key_o
);

`include "clog_function.vh"

reg [DEPTH*DATA_WIDTH-1:0] keys_even_memory;

initial begin
		keys_even_memory = 'b0;
end

always @(posedge clk_i or negedge reset_ni) begin
	if(~reset_ni)
		keys_even_memory[(key_index-1)*DATA_WIDTH+:DATA_WIDTH] <= 'b0;
	else	
		if(keygen_en_i)
			keys_even_memory[(key_index-1)*DATA_WIDTH+:DATA_WIDTH] <= even_key_i;
end

assign even_key_o = keys_even_memory;

endmodule