module function_h
#(
	parameter DATA_WIDTH = 32
)
(
    input 					    clk_i		   ,
    input 					    reset_ni       ,
    input      [DATA_WIDTH-1:0] data_i         ,
    input      [DATA_WIDTH-1:0] key_schedule0_i,
    input      [DATA_WIDTH-1:0] key_schedule1_i,
	
    output     [DATA_WIDTH-1:0] data_o
);

wire [(DATA_WIDTH/4)-1:0] sbox0	    ;
wire [(DATA_WIDTH/4)-1:0] sbox1	    ;
wire [(DATA_WIDTH/4)-1:0] sbox2	    ;
wire [(DATA_WIDTH/4)-1:0] sbox3	    ;
wire [DATA_WIDTH-1:0] 	  mds_yield ;

s_box_combined 
#(
	.DATA_WIDTH(DATA_WIDTH)
)
s_box_combined_inst
(
	.clk_i			(clk_i			),
	.reset_ni		(reset_ni		),
    .data_i			(data_i			),
    .key_schedule0_i(key_schedule0_i),
    .key_schedule1_i(key_schedule1_i),
	
    .box0_o			(sbox0			),
    .box1_o			(sbox1			),
    .box2_o			(sbox2			),
    .box3_o			(sbox3			)
);
 
mds 
#(
	.DATA_WIDTH(DATA_WIDTH/4)
)
mds_inst
(
	.clk_i			(clk_i    ),
	.reset_ni		(reset_ni ),
    .box0_i			(sbox3	  ),
    .box1_i			(sbox2	  ),
    .box2_i			(sbox1	  ),
    .box3_i			(sbox0	  ),
    .mds_o 			(mds_yield)
);


assign data_o = mds_yield;


endmodule