module function_f_singleHinstTB();

`include "clog_function.vh"

parameter DATA_WIDTH = 32;

reg 						    clk_i		 ;
reg 						    reset_ni     ;
reg      [DATA_WIDTH-1:0] 	    R0_i		 ;
reg      [DATA_WIDTH-1:0] 	    R1_i		 ;
reg      [DATA_WIDTH-1:0] 	    S0_i		 ;
reg      [DATA_WIDTH-1:0] 	    S1_i		 ;
reg      [DATA_WIDTH-1:0] 	    K_key_even_i ;
reg      [DATA_WIDTH-1:0]       K_key_odd_i	 ;
                                
wire 	 [DATA_WIDTH-1:0]  	    F0_o		 ;
wire 	 [DATA_WIDTH-1:0]  	    F1_o		 ;   	              
		   
function_f_singleHinst                  		   
#(
	.DATA_WIDTH(DATA_WIDTH)
)
function_f_single_instDUT
(
	.clk_i		 (clk_i		  ),
	.reset_ni    (reset_ni    ),
	.R0_i		 (R0_i		  ),
	.R1_i		 (R1_i		  ),
	.S0_i		 (S0_i		  ),
	.S1_i		 (S1_i		  ),
	.K_key_even_i(K_key_even_i),
	.K_key_odd_i (K_key_odd_i ),	
	
	.F0_o		(F0_o		  ),
	.F1_o		(F1_o		  )
);

always begin
	#15 clk_i <= ~clk_i;
end

initial begin
	clk_i = 'b0;
	reset_ni = 'b1;
	R0_i ='bx;
	R1_i ='bx;
	S0_i ='b0;
	S1_i ='b0;
	@(posedge clk_i)
	reset_ni ='b0;
	R0_i ='b0;
	R1_i ='b0;
	@(posedge clk_i)
	reset_ni = 'b1;
	K_key_odd_i = 'h0;
	K_key_even_i = 'h0;
	R0_i =32'h52c54dde;
	R1_i =32'h11f0626d;
	@(posedge clk_i)
	K_key_odd_i = 32'h9c5b3c17;
	K_key_even_i = 32'hf98ffef9;
end

endmodule