`timescale 1ns/1ps
module key_generatorTB();

parameter DATA_WIDTH = 32;
parameter COUNT_TO	 = 19;

reg 						   clk_i		;
reg 						   reset_ni	    ;
reg 						   keygen_en_i  ;
reg      [(DATA_WIDTH*4)-1:0]  globalkey_i  ;

wire  	 [DATA_WIDTH-1:0]  	   K_key_odd_o	;
wire  	 [DATA_WIDTH-1:0]  	   K_key_even_o	;

key_generator
#(
	.DATA_WIDTH(DATA_WIDTH),
	.COUNT_TO(COUNT_TO)
)
key_generatorDUT
(
	.clk_i		 (clk_i		  ),
	.reset_ni	 (reset_ni	  ),  
	.keygen_en_i (keygen_en_i ),
	.globalkey_i (globalkey_i ),
	
	.K_key_odd_o (K_key_odd_o ),
	.K_key_even_o(K_key_even_o)
);

always begin
	#15 clk_i <= ~clk_i;
end

initial begin
	clk_i = 'b0;
	reset_ni = 'b1;
	keygen_en_i = 'b0;
	globalkey_i = 'h0;
	@(posedge clk_i)
	reset_ni = 'b0;
	@(posedge clk_i)
	reset_ni = 'b1;
	@(posedge clk_i)
    @(posedge clk_i)
    @(posedge clk_i)
	keygen_en_i = 'b1;
end
endmodule