module mdsTB();

parameter DATA_WIDTH = 8;

reg clk_i;
reg reset_ni;
reg enable_i;
reg [DATA_WIDTH-1:0] box0_i;
reg [DATA_WIDTH-1:0] box1_i;
reg [DATA_WIDTH-1:0] box2_i;
reg [DATA_WIDTH-1:0] box3_i;

wire [(DATA_WIDTH*4)-1:0] mds_o;

mds 
#(
.DATA_WIDTH(DATA_WIDTH)
)
mdsDUT(
.clk_i(clk_i),
.reset_ni(reset_ni),
.enable_i(enable_i),
.box0_i(box0_i),
.box1_i(box1_i),
.box2_i(box2_i),
.box3_i(box3_i),
.mds_o(mds_o)  
);

always begin
#15 clk_i = ~clk_i;
end

initial begin
clk_i = 'b0;
reset_ni = 'b1;
enable_i = 'b0;
box0_i = {8{1'bx}};
box1_i = {8{1'bx}};
box2_i = {8{1'bx}};
box3_i = {8{1'bx}};
@(posedge clk_i)
reset_ni = 'b0;
@(posedge clk_i)
reset_ni = 'b1;
@(posedge clk_i)
box0_i = 'hff;
box1_i = 'd2;
box2_i = 'd3;
box3_i = 'd4;
@(posedge clk_i)
enable_i = 'b1;
@(posedge clk_i)
box0_i = 'bx;
box1_i = 'bx;
box2_i = 'bx;
box3_i = 'bx;
@(posedge clk_i)
enable_i = 'b0;
end

endmodule